@import '@design';

// import all local fonts
@include import-webfonts();

// Using font as CSS variables, to reduce size of generated CSS.
:root {
  @include design-tokens--();
}

// Import normalization
@import '~accoutrement/sass/init';

// stylelint-disable

html {
  @include use-text-style('body');

  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  -ms-overflow-style: auto; // restore styles overwritten by accoutrement
}

body {
  padding-top: size('header');
  color: color('text');
}

svg {
  vertical-align: middle;
}

img {
  display: inline-block;
  max-width: 100%;
  height: auto;
  vertical-align: middle;
  -ms-interpolation-mode: bicubic;
}

a {
  color: color('text');
  text-decoration: none;
}

h1,
h2,
h3,
h4,
h5,
h6 {
  @include use-text-style('heading');
}

label {
  display: block;
  margin-bottom: 0.7rem;
  color: color('primary-300');

  @include use-text-style('type');
  @include use-text-style('type-200');

  @include above('large') {
    @include use-text-style('type-100');
  }
}

input[type='text']:not(.tw-input),
input[type='email']:not(.tw-input),
input[type='tel']:not(.tw-input),
textarea {
  display: block;
  width: 100%;
  padding: 1.4rem 2rem;
  font-size: 1.6rem;
  color: color('text');
  border: 1px solid color('border');
  border-radius: 4px;

  &::-webkit-input-placeholder {
    color: color('primary-200');
  }

  &:-ms-input-placeholder {
    color: color('primary-200');
  }

  &::placeholder {
    color: color('primary-200');
  }
}

button:disabled {
  cursor: not-allowed;
}

select {
  display: block;
  width: 100%;
  padding: 1.4rem 2rem;
  font-size: 1.6rem;
  background-image: url('~assets/images/select-arrow.svg');
  background-repeat: no-repeat;
  background-position: 97% 45%;
  border: 1px solid color('border');
  border-radius: 4px;
  appearance: none;

  &:disabled,
  &[disabled] {
    cursor: default;
    opacity: 0.4;
  }

  // no height or background for multi select
  &[multiple='multiple'] {
    height: auto;
    background-image: none;
  }

  // IE hide the select arrow
  &::-ms-expand {
    display: none;
  }
}

// Styled checkboxes
.checkbox,
.radio {
  label {
    position: relative;
    padding-left: 4rem;
    margin: 0;
    cursor: pointer;

    &::before,
    &::after {
      position: absolute;
    }

    // box
    &::before {
      top: 0;
      left: 0;
      display: inline-block;
      width: 2rem;
      height: 2rem;
      content: '';
      border: 2px solid #f2f2f2;
    }

    // tick
    &::after {
      top: 5px;
      left: 4px;
      display: inline-block;
      width: 12px;
      height: 7px;
      content: '';
      border-bottom: 2px solid color('white');
      border-left: 2px solid color('white');
      transform: rotate(-45deg);
    }
  }

  input[type='checkbox']+label::after,
  input[type='radio']+label::after {
    content: none;
  }

  input[type='checkbox'][data-focus-visible-added]:focus+label::before,
  input[type='radio'][data-focus-visible-added]:focus+label::before {
    outline: rgb(59, 153, 252) auto 5px;
  }

  input[type='checkbox']:checked+label::before,
  input[type='radio']:checked+label::before {
    background-color: color('text');
    border-color: color('text');
  }

  input[type='checkbox']:checked+label::after,
  input[type='radio']:checked+label::after {
    content: '';
  }
}

table {
  width: 100%;
}

th {
  font-weight: normal;
}

// stylelint-enable

::selection {
  color: color('text');
  background: color('secondary');
}

.js-focus-visible :focus:not([data-focus-visible-added]) {
  outline: none;
}

[data-focus-visible-added] {
  outline-style: auto;
}

// utility classes
.u-wrap {
  max-width: 131rem;
  margin-right: auto;
  margin-left: auto;
}

.u-visuallyhidden {
  position: absolute;
  width: 1px;
  height: 1px;
  padding: 0;
  margin: -1px;
  overflow: hidden;
  clip: rect(0 0 0 0);
  border: 0;
}

.u-font-secondary {
  @include font-family('secondary');
}

.u-heading {
  @include font-family('secondary');
  @include use-text-style('heading-500');

  margin-bottom: size('m');
  text-align: center;

  @include above('xlarge') {
    @include use-text-style('heading-700');

    margin-bottom: size('l');
  }

  &--pre-line {
    white-space: pre-line;
  }
}

.u-subheading {
  @include use-text-style('heading-100');

  margin-top: size('s') - size('m');
  margin-bottom: size('m');
  color: color('primary-100');
  text-align: center;

  @include above('xlarge') {
    @include use-text-style('heading-200');

    margin-top: size('s') - size('l');
    margin-bottom: size('l');
  }

  &--pre-line {
    white-space: pre-line;
  }
}

.u-block-spacing {
  &:not(.u-block-spacing-first-no-top-spacing) {
    margin-top: size('xl');

    @include above('xlarge') {
      margin-top: size('xxl');
    }
  }

  &:not(:last-child),
  &:last-child:not(.u-block-spacing-last-no-bottom-spacing) {
    margin-bottom: size('xl');

    @include above('xlarge') {
      margin-bottom: size('xxl');
    }
  }

  &.u-block-no-bottom-spacing {
    margin-bottom: 0;
  }

  &.u-block-no-top-spacing {
    margin-top: 0;
  }
}

.u-block-spacing-possibly-touch-previous {
  .u-block-spacing-has-inner+& {
    margin-top: -1 * size('xl');

    @include above('xlarge') {
      margin-top: -1 * size('xxl');
    }
  }
}

.no-block-spacing.no-block-spacing .u-block-spacing {
  margin-top: 0;
  margin-bottom: 0;
}

.u-copy {
  @include use-text-style('type');
  @include use-text-style('type-100');

  color: color('primary-100');

  &--pre-line {
    white-space: pre-line;
  }
}

.u-nolist {
  list-style: none;
}

.grecaptcha-badge {
  display: none !important;
}

.screen-reader-only {
  position: absolute;
  width: 1px;
  height: 1px;
  padding: 0;
  margin: -1px;
  overflow: hidden;
  clip: rect(0 0 0 0);
  clip-path: polygon(0 0, 0 0, 0 0);
  white-space: nowrap;
  border: 0;
}

// slide from right
.slide-from-right-leave-active,
.slide-from-right-enter-active {
  transition: time('slow');
}

.slide-from-right-enter,
.slide-from-right-leave-to {
  opacity: 0;
  transform: translate(100%, 0);
}

// simple fade
.fade-enter-active,
.fade-leave-active {
  @include transition('fade');
}

.fade-enter,
.fade-leave-to {
  opacity: 0;
}

// fade in and out
.fade-in-out-enter,
.fade-in-out-leave-to {
  opacity: 0;
}

.fade-in-out-leave,
.fade-in-out-enter-to {
  opacity: 1;
}

.fade-in-out-leave-active {
  position: absolute;
  top: 0;
  right: 0;
  left: 0;
}

.fade-in-out-enter-active,
.fade-in-out-leave-active {
  @include transition('fade');
}
